#include "PortCom.h"

HANDLE ComHandle;       //Handle pro COM

//--------------------------------------------------------------------------//
// Otevr COM port pro dalsi pouziti
bool OpenCom(int CisloComu)
{
  char JmenoComu[6];

  CloseHandle(ComHandle);
  sprintf(JmenoComu,"COM%i",CisloComu);
  ComHandle=CreateFile(JmenoComu,GENERIC_READ|GENERIC_WRITE,
                          0,NULL,OPEN_EXISTING,0,NULL);
  if(ComHandle==INVALID_HANDLE_VALUE) return (0);
  else return (1);
}
//--------------------------------------------------------------------------//
// Uzavre COM port
void CloseCom(void)
{
  CloseHandle(ComHandle);
}
//--------------------------------------------------------------------------//
// Podle predaneho parametru nastavi DTR
void SetDTR(bool x)
{
  EscapeCommFunction( ComHandle,x ? SETDTR : CLRDTR );
}
//--------------------------------------------------------------------------//
// Podle predaneho parametru nastavi RTS
void SetRTS(bool x)
{
  EscapeCommFunction( ComHandle,x ? SETRTS : CLRRTS );
}
//--------------------------------------------------------------------------//
// Podle predaneho parametru nastavi TX
void SetTX(bool x)
{
  EscapeCommFunction( ComHandle,x ? SETBREAK : CLRBREAK );
}
//--------------------------------------------------------------------------//
// Nacte stav vstupu CTS
bool GetCTS(void)
{
  DWORD ModemStatus;
  GetCommModemStatus(ComHandle,&ModemStatus);
  ModemStatus=ModemStatus & MS_CTS_ON;
  return ((bool)ModemStatus);
}
//--------------------------------------------------------------------------//
// Nacte stav vstupu DSR
bool GetDSR(void)
{
  DWORD ModemStatus;
  GetCommModemStatus(ComHandle,&ModemStatus);
  ModemStatus=ModemStatus & MS_DSR_ON;
  return ((bool)ModemStatus);
}
//--------------------------------------------------------------------------//
// Nacte stav vstupu RING
bool GetRing(void)
{
  DWORD ModemStatus;
  GetCommModemStatus(ComHandle,&ModemStatus);
  ModemStatus=ModemStatus & MS_RING_ON;
  return ((bool)ModemStatus);
}
//--------------------------------------------------------------------------//
// Nacte stav vstupu RLSD
bool GetRLSD(void)
{
  DWORD ModemStatus;
  GetCommModemStatus(ComHandle,&ModemStatus);
  ModemStatus=ModemStatus & MS_RLSD_ON;
  return ((bool)ModemStatus);
}
//--------------------------------------------------------------------------//
// Prodlevu v mikrosekundach
void Wait_us(unsigned __int64 prodleva)
{
 unsigned __int64 frekvence,citac,stop;
  QueryPerformanceCounter((LARGE_INTEGER *)&citac);
  QueryPerformanceFrequency((LARGE_INTEGER *)&frekvence);
  stop=((prodleva*frekvence)/1000000)+citac+1;
  while  (stop>citac) QueryPerformanceCounter((LARGE_INTEGER *)&citac);
}
//--------------------------------------------------------------------------//
// Prodleva v milisekundach
void Wait_ms(int prodleva)
{
 int stop ;
  timeBeginPeriod (1);
  stop = timeGetTime() + prodleva;
  while (stop>timeGetTime ());
  timeEndPeriod (1);
}
//---------------------------------------------------------------------------







